<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>PythonCAD Download Page</title>
<link href="stylesheets/pythoncad.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
<div id="header">
<div id="main_logo"><a href="index.html" title="PythonCAD Home"><img src="images/main_logo.png" alt="PythonCAD" /></a></div>
</div><!-- header -->
<div id="main_content">
<h2>PythonCAD Code Retrieval</h2>
<p>
Each release is made as a compressed tar archive. For those wishing to
participate in development, or if you just want the most current development
code, there are two options, using <a href="http://git.or.cz">git</a> or
<a href="http://subversion.tigris.org">subversion</a> for retrieving the
code. The main PythonCAD repo was formerly kept in Subversion but now has
switched to git, but the subversion repo still is kept current with whatever
changes are applied to the git repository.
</p>
<p>
The switchover to git allows for a distributed development model, an approach
not available out-of-the box with subversion. The initial cloning of the
git PythonCAD pulls all the code changes of PythonCAD to your system,
giving you the complete history of the project. You can locally create branches
to try out ideas, commit any changes you make to your local repo, all the
while updating and merging the main development tree. The storage requirements
of git are smaller than that of Subversion, and there are other advantages
that git offered which made the transition to converting the main
repository worthwhile.
</p>
<p>
A quick word or two about version number. The initial plan is to use a
version numbering scheme like <strong>DS</strong>-#-<strong>R</strong>-#,
where the <strong>DS</strong> means <q><strong>D</strong>evelopment
<strong>S</strong>eries</q>, the <strong>R</strong> is for
<q><strong>R</strong>elease</q>, and the <q>#</q> characters
are replaced with numbers. As the development of PythonCAD has just begun,
the releases are all part of development series 1 (DS1). Each release will
be tagged in the master repository. When the day comes for the first
official release, it was be released with a version string of
<strong>SS</strong>-#-<strong>R</strong>-#, with the <strong>SS</strong>
meaning <q><strong>S</strong>table <strong>S</strong>eries</q>. After
a few stable releases, the development series releases will resume again,
this time at development series 2 (DS2).
</p>
<h3>Current Release</h3>
<p>
Highlights of the thirty-sixth release ...
</p>
<ul>
<li>
Windows preferences now saved to <q>env[APPDATA]/PythonCAD</q> directory.
</li>
<li>
Bug fixes and code improvements.
</li>
</ul>
<p>
Use the following links to download the thirty-sixth PythonCAD release:
</p>
<ul>
<li>
<a href="releases/PythonCAD-DS1-R36.tar.bz2">PythonCAD-DS1-R36.tar.bz2</a>
</li>
<li>
<a href="releases/PythonCAD-DS1-R36.tar.gz">PythonCAD-DS1-R36.tar.gz</a>
</li>
</ul>
<p>
<strong>Note:</strong> Users of PythonCAD with the Cocoa-based front end
should not use this release. The Cocoa front-end is not functional
as the main developer no longer has time to maintain the code. Various
patches have been applied to attempt to resuscitate the Cocoa code, but
there is still more work needing to be done. I do not have a machine
running Mac OS X so I cannot test any patches for this front end.
If you are interested in reviving the Cocoa front end, please install
<a href="http://subversion.tigris.org">Subversion</a>, check the code
out from the public repository, and send patches.
</p>
<p>
A <q>spec</q> file used to create RPM packages was added to PythonCAD
with the nineteenth release. Links to built RPM packages for the current
release will be added to this page if the packages are created by someone
and they notify <a href="mailto:ahaas@airmail.net">me</a>.
</p>
<p>
D. Scott Barninger &lt;barninger at fairfieldcomputers dot com&gt;, author
of the <q>.spec</q> file, contributed RPM packages for the thirty-fourth
release. They are available below by clicking on one of the links in
the table.
</p>
<table border="1" cellpadding="0" cellspacing="0" width="90%" summary="PythonCAD RPM Packages">
 <tr>
  <td align="center" colspan="2"><strong>RPM Packages</strong></td>
 </tr>
 <tr>
  <th>Distribution</th>
  <th>File</th>
 </tr>
 <tr>
  <th>Mandrake</th>
  <th><a href="rpms/PythonCAD-0.1.34-1.mdk.python24.noarch.rpm">PythonCAD-0.1.34-1.mdk.python24.noarch.rpm</a></th>
 </tr>
 <tr>
  <th>Fedora, Redhat [Python2.2]</th>
  <th><a href="rpms/PythonCAD-0.1.34-1.redhat.python22.noarch.rpm">PythonCAD-0.1.34-1.redhat.python22.noarch.rpm</a></th>
 </tr>
 <tr>
  <th>Fedora, Redhat [Python2.4]</th>
  <th><a href="rpms/PythonCAD-0.1.34-1.redhat.python24.noarch.rpm">PythonCAD-0.1.34-1.redhat.python24.noarch.rpm</a></th>
 </tr>
 <tr>
  <th>SuSE [Python2.3]</th>
  <th><a href="rpms/PythonCAD-0.1.34-1.suse.python23.noarch.rpm">PythonCAD-0.1.34-1.suse.python23.noarch.rpm</a></th>
 </tr>
 <tr>
  <th>SuSE [Python2.4]</th>
  <th><a href="rpms/PythonCAD-0.1.34-1.suse.python24.noarch.rpm">PythonCAD-0.1.34-1.suse.python24.noarch.rpm</a></th>
 </tr>
 <tr>
  <th>Source RPM</th>
  <th><a href="rpms/PythonCAD-0.1.34-1.src.rpm">PythonCAD-0.1.34-1.src.rpm</a></th>
 </tr>
</table>
<p>
The key used to generate and sign these packages is here: <a href="rpms/rpmkey-suser-sbarnin-0.1-2.noarch.rpm">RPMKey</a> Anyone with questions about thes
packages should contact him via the e-mail address above. For those of you
wishing to download the source package and built it yourself, he provided
the following instruction:
</p>
<pre>
$ rpmbuild --rebuild --define <q>build_xxx 1</q> PythonCAD-0.1.34.src.rpm
</pre>
<p>
Replace <q>build_xxx</q> with either <q>build_rhel</q>, <q>build_suse</q>,
or <q>build_mdk</q>.
</p>
<h3>Git Repository Access</h3>
<p>
<a href="http://git.or.cz">Git</a> was created by Linus Torvalds to handle
the kernel tree source code after the use of Bitkeeper ceased to be an option.
Git itself is capable of handling enourmous numbers of files while keeping
blazing performance. Git is commonly available in current Linux distributions,
or you can download, build, and install it yourself.
</p>
<pre>
$ git clone git://repo.or.cz/pythoncad.git
</pre>
<p>
Once this command finishes you will have a <q>pythoncad.git</q> directory
with the program source code and web pages. There is also the start
of a regression test suite as well.
</p>
<p>
You can update your tree by invoking the following command:
</p>
<pre>
$ git pull
</pre>
<p>
Any changes available at the main tree will be pulled down to your copy
and merged in, if possible.
</p>
<p>
Git offers many, many commands for managing source code trees, far too
many to list here. The documentation for git is available online
<a href="http://www.kernel.org/pub/software/scm/git/docs/">here</a>, and
more information is available <a href="http://git.or.cz/gitwiki/GitDocumentation">here</a>.
</p>
<h3>Subversion Repository Access</h3>
<p>
<a href="http://subversion.tigris.org">Subversion</a> installation
instructions can be found at their website, as well as documentation about
program usage. If you have used CVS, then using Subversion should seem
familiar, and various projects (such as Apache, KDE, and Gnome) have
converted their CVS repositories to Subversion. Most current Linux distros
provide Subversion as a standard package, and I suspect most current BSD
flavors do the same as well.
</p>
<p>
Once you get Subversion installed, retrieve the PythonCAD code with the
following command:
</p>
<pre>
$ svn co http://subversion.pythoncad.org:9000/svn/pythoncad/trunk pythoncad
</pre>
<p>
This command will create a <q>pythoncad</q> directory, and the code
will be found there. The directory will also contain the copy of these
web pages and a directory with some regression testing code. These tests
are all based on the <q>unittest</q> module from Python. The test
suite is not complete, and many tests should be added. The existing tests
can be thought of as a starting point for a full test suite.
</p>
<p>
After checking out the code from the repository, you will need to periodically
update your copy. Change back into the <q>pythoncad</q> directory and
run this command:
</p>
<pre>
$ svn update
</pre>
<p>
Any changes in the master repository should then make their way to your
local copy. See the Subversion documentation for details about resolving
any possible conflicts.
</p>
<p>
If you wish to create a patch for PythonCAD, use the following command
to generate the patch:
</p>
<pre>
$ svn diff foo.py &gt; foo.diff
</pre>
<p>
Replace <q>foo.py</q> with the filename you want to patch, obviously,
then mail me the patch. It will get reviewed and possibly applied, hopefully
very soon after the patch is received.
</p>
<p>
If you have a problem accessing the subversion repository, please send
<a href="mailto:ahaas@airmail.net">me</a> some mail and I will try
to get the problem fixed as soon as possible.
</p>
</div><!-- main_content -->
<div id="footer">
<h3>Site Hosting Information</h3>
<div id="hwm">
PythonCAD is hosted by <a href="http://www.hwm-usa.com/">Hughes Web Marketing</a>
</div><!-- hwm -->
<div id="w3c">
This page is <a href="http://validator.w3.org/check/referer">Valid XHTML 1.0</a>.
</div><!-- w3c -->
</div><!-- footer -->
</body>
</html>
